package envoy.server.data;

import java.util.Date;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * Project: <strong>envoy-server-standalone</strong><br>
 * File: <strong>User.java</strong><br>
 * Created: <strong>02.01.2020</strong><br>
 * 
 * @author Kai S. K. Engelbart
 * @since Envoy Server Standalone v0.1-alpha
 */
@Entity
public class User {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private long						id;
	private String						name;
	private byte[]						passwordHash;
	@Temporal(TemporalType.TIMESTAMP)
	private Date						lastSeen;
	private envoy.data.User.UserStatus	status;
	private List<User>					contacts;

	public long getId() { return id; }

	public void setId(long id) { this.id = id; }

	public String getName() { return name; }

	public void setName(String name) { this.name = name; }

	public byte[] getPasswordHash() { return passwordHash; }

	public void setPasswordHash(byte[] passwordHash) { this.passwordHash = passwordHash; }

	public Date getLastSeen() { return lastSeen; }

	public void setLastSeen(Date lastSeen) { this.lastSeen = lastSeen; }

	public envoy.data.User.UserStatus getStatus() { return status; }

	public void setStatus(envoy.data.User.UserStatus status) { this.status = status; }

	public List<User> getContacts() { return contacts; }

	public void setContacts(List<User> contacts) { this.contacts = contacts; }
}
